<?php
/*
Plugin Name: Spamaway
Author: kmxz
Author URI: http://kongxz.com/
*/

//本插件将放过一切登陆用户，只对访客评论进行检查，下面是配置

define('FS_URL_FILTER', 2 );
/*
对链接URL的要求
0：没有任何要求
1：必须友情链接中的站点
2：必须是友情链接中的站点或WordPress站点（影响速度！）
*/

define('FS_URL_FILTER_ACTION', 1 );
/*
对不符合上述要求的内容
0：要求其输入CAPTCHA
1：询问是删去URL还是放弃评论
*/

define('FS_CHINESE_FILTER', 1 );
/*
是否要求评论中（名称、正文）包含中文
0：不要求
1：要求
*/

define('FS_CHINESE_FILTER_ACTION', 0 );
/*
对不符合上述要求的内容
0：要求其输入CAPTCHA
*/

add_action('comment_form','fs_display_warning'); //如果不需要显示URL要求的警告气泡，直接把此行注释掉即可

define('FS_STYLE_BUBBLE','padding:0px 5px;color:#000;display:none;height:20px;line-height:20px;background:#ffffff;font-size:14px;');
/* 定义警告气泡的CSS样式 */

add_filter('preprocess_comment','fs_process_comment');

function fs_show_captcha($unique) { //显示验证码
	return '<p>请输入右侧的验证码：<input type="text" name="captcha" maxlength="4" /><img src="'.get_option('siteurl').'/wp-content/plugins/spamaway/captcha.php?unique='.$unique.'" /></p>';	
}

function fs_check_chinese($comment) { //检查给定comment中是否包含中文
	if( (!preg_match_all('/[一-龥]/u', $comment['comment_content'], $match)) && (!preg_match_all('/[一-龥]/u', $comment['comment_author'], $match)) ){
		return false;
	} else { return true; }
}

function fs_check_friend_link($url){ //检查url是否在blogroll中
	$bookmarks = get_bookmarks( array('orderby' => 'id', 'order' => 'ASC', 'limit' => -1, 'hide_invisible' => 0, 'show_updated' => 0, 'include' => null,'exclude' => null, 'search' => null)); 
	$links=array();
	foreach ($bookmarks as $link) {
    	if(strpos('/'.$link->link_url.'/',$url)){ return true; }
	}
	return false;
}

function fs_check_is_wordpress($url) { //通过探测wp-register.php判定url是否指向一个WordPress站点
	$context = stream_context_create(array ('http'=>array('method'=>"GET",'timeout'=>5)) );
	if(substr($url,-1,1)!='/') { $url.='/'; }
	$url.= 'wp-register.php';
	$cnt=0;
    while($cnt < 2 && ($html=@file_get_contents($url, false, $context))===FALSE) { $cnt++; }
	if (strpos($html,'<body class="login">')) {
		return true;
	} else { return false; }
}

function fs_process_comment($comment_array) {
	if (is_user_logged_in()) { return $comment_array; }
	if (FS_CHINESE_FILTER) {
		$chinese = fs_check_chinese($comment_array);
	} else { $chinese = $true; }
	if (FS_URL_FILTER && $comment_array['comment_author_url']!='') {
	    $url = fs_check_friend_link($comment_array['comment_author_url']);
		if ( FS_URL_FILTER==2 && !$url ) {
			$url = fs_check_is_wordpress($comment_array['comment_author_url']);	
		}
	} else { $url = true; }
	if ($chinese && $url) { return $comment_array; } //若都符合，直接返回。以下为需要wp_die()时的处理
	//判断需要的处理
	$captcha = false;
	$warning = false;
	if (!$chinese) { $captcha = true; }
	if (!$url && (FS_URL_FILTER_ACTION==0)) { $captcha = true; }
	if (!$url && (FS_URL_FILTER_ACTION==1)) { $warning = true; }
	//判断处理是否已经被满足
	if (isset($_POST['unique'])) {
		$unique = $_POST['unique'];
		if ($warning) {
			if ($_POST[$unique.'_SUBMIT'] != '删除我的URL，继续发表评论') {
			    wp_die('<p>您的评论将不会被发表，谢谢支持。</p><p><a href="'.get_permalink($_POST['comment_post_ID']).'">点击返回</a></p>','Spamaway',array('response'=>'200'));
			} 
			$comment_array['comment_author_url']='';
		}
		if ($captcha) {
			@session_start();
			if ($_SESSION[$unique.'_CAPTCHA'] != $_POST['captcha']) { wp_die('<p>对不起，验证码不正确，请返回上一页重新输入。</p>','Spamaway',array('back_link'=>true,'response'=>'200')); }
		}
		return $comment_array;
	}
	//若尚未满足，生成表单
	$unique=substr(md5(mt_rand(0,10000)),10,10);
	$die='<p><strong>Spamaway插件给您添麻烦了！</strong></p>';
	$die.='<form action="'.get_option('siteurl').'/wp-comments-post.php" method="post">';
	$die.='<input type="hidden" name="unique" value="'.$unique.'" />';
	foreach ($_POST as $key => $content) {$die.= '<input type="hidden" name="'.$key.'" value="'.htmlspecialchars($content,ENT_QUOTES).'" />'; } //The players tried for a forward pass
	if ($captcha) {
		$die.=fs_show_captcha($unique);
	}
	if ($warning) {
		$die.='<p>对不起，您填写的URL不被博主允许，请选择：</p>';
		$die.='<p><input type="submit" name="'.$unique.'_SUBMIT" value="删除我的URL，继续发表评论" /> <input type="submit" name="'.$unique.'_SUBMIT" value="放弃发表此条评论" /></p>';
	} else { $die.='<p><input type="submit" value="提交"/></p>'; }
	$die.= '</form>';
	wp_die($die,'Spamaway',array('response'=>'200'));
}

function fs_display_warning() {
	if (is_user_logged_in() || !FS_URL_FILTER) { return; }
?>
<div id="fs_warn" style="position:absolute;<?php echo FS_STYLE_BUBBLE; ?>"><?php echo (FS_URL_FILTER==1 ? '评论URL仅允许填写本博客友情链接列表中的地址' : '评论URL仅允许填写WordPress架设的博客或本博客友情链接列表中的地址'); ?></div>  
<script language="javascript">
function fsDisplayWarning() {
	var forms = document.getElementsByTagName('form');
	for (var i=0;i<forms.length;i++) {
		if (forms[i].action=="<?php echo get_option('siteurl'); ?>/wp-comments-post.php") { var form=forms[i]; }
	}
	var inputs = form.getElementsByTagName('input');
	for (i=0;i<inputs.length;i++) {
		if (inputs[i].name=="url") { var urlinput=inputs[i]; }
	}
    urlinput.onfocus=function() { 
        var l=this.offsetLeft;  
        var t=this.offsetTop-23; 
		var d=document.getElementById("fs_warn");  
        d.style.left=l+"px";  
        d.style.top=t+"px";  
        d.style.display=""; 
    };

    urlinput.onblur=function() {
       document.getElementById("fs_warn").style.display='none'; 
    };
}
</script>

<!--[if !IE]><!-->
<script language="javascript">
fsDisplayWarning();
</script>
<!--<![endif]-->
<?php
}
?>